## libzrtpcpp 2.0.0

=== CMakeLists.txt ===
# Copyright (C) 2009 Werner Dittman
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
cmake_minimum_required(VERSION 2.6)

PROJECT(libzrtpcpp)

SET(CPACK_PACKAGE_VERSION_MAJOR 2)
SET(CPACK_PACKAGE_VERSION_MINOR 0)
SET(CPACK_PACKAGE_VERSION_PATCH 0)

set (VERSION 2.0.0)
set (SOVERSION 2)
set (PACKAGE libzrtpcpp)

if(MSVC60)
    set(BUILD_STATIC ON CACHE BOOL "static linking only" FORCE)
    MARK_AS_ADVANCED(BUILD_STATIC)
else()
    option(BUILD_STATIC "Set to OFF to build shared libraries" OFF)
endif()

# set to true for debug and trace during CMakeLists development
set(CMAKE_VERBOSE_MAKEFILE FALSE)

MESSAGE( STATUS "Configuring GNU ${PROJECT_NAME} ${VERSION}...")

# include most of the fine stuff we need
include(cmake/Modules/FindGcryptConfig.cmake)
include(FindPkgConfig)
include(CheckLibraryExists)
include(CheckIncludeFiles)
include(cmake/Modules/AutoArgs.cmake)

if(${PROJECT_NAME} STREQUAL ${CMAKE_PROJECT_NAME})
    include(cmake/Modules/GeneratePackage.cmake)

    GENERATE_PACKAGING(${PACKAGE} ${VERSION})
endif()

# check the -Denable-ccrtp setting, defaults to true
enable_arg(ccrtp true "Enable GNU ccRTP support for GNU ZRTP")
args_help()

# this caused problems in debian where it has to always be lib....
set(LIBDIRNAME "lib")
if (NOT EXISTS /etc/debian_version)
    if ( "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" )
        set(LIBDIRNAME "lib64")
    endif()
endif()

# setup the Thread include and lib
find_package(Threads)
if(CMAKE_HAVE_PTHREAD_H)
  set(HAVE_PTHREAD_H TRUE)
endif()
set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})

if(enable_ccrtp)
    if (USES_CCRTP_INCLUDE_DIRS)
        message(STATUS "  Using local commoncpp dependency")
    else()
        find_package(PkgConfig)
        pkg_check_modules(USES_CCRTP libccrtp>=2.0.0)
    endif()
    include_directories(${USES_CCRTP_INCLUDE_DIRS})
    link_directories(${USES_CRTP_LIBRARY_DIRS})
    add_definitions(${USES_CCRTP_CFLAGS})
    set (LIBS ${LIBS} ${USES_CCRTP_LDFLAGS} ${USES_CCRTP_LIBRARIES})
endif()

# now get info about crypto libraries
gcr_check(GCRYPT gcrypt)
#if(GCRYPT_FOUND)
#  check_include_files(gcrypt.h HAVE_GCRYPT_H)
#  set(LIBS ${LIBS} ${GCRYPT_LIBRARIES})
#  set(BUILD_REQ "libgcrypt-devel")
#  set(CRYPTOBACKEND="")
#  set(PACKAGE_REQ "libgcrypt")
#else()
  pkg_check_modules(OPENSSL libcrypto>=0.9.8)
  if (OPENSSL_FOUND)
    check_include_files(openssl/bn.h HAVE_OPENSSL_BN_H)
    check_include_files(openssl/aes.h HAVE_OPENSSL_AES_H)
    check_include_files(openssl/sha.h HAVE_OPENSSL_SHA_H)
    check_library_exists(crypto EVP_CipherInit_ex "" HAVE_SSL_CRYPT)
    set(LIBS ${LIBS} -lcrypto)
    set(CRYPTOBACKEND "libcrypto >= 0.9.8")
    set(BUILD_REQ "libopenssl-devel >= 0.9.8")
    set(PACKAGE_REQ "libopenssl >= 0.9.8")
  else()
    message(FATAL_ERROR "No crypto library found")
  endif()
#endif()

check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(string.h HAVE_STRING_H)

# necessary and required modules checked, ready to generate config.h
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# the following set(...) commands are only to have backward
# compatibility with autoconf stuff to generate the pc file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix}/bin)
set(libdir ${prefix}/lib)
set(includedir ${prefix}/include)
set(PACKAGE pkgconfig)
configure_file(libzrtpcpp.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libzrtpcpp.pc @ONLY)

configure_file(libzrtpcpp.spec.cmake ${CMAKE_CURRENT_BINARY_DIR}/libzrtpcpp.spec @ONLY)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)

add_definitions(-g -O2 -fno-strict-aliasing)
if(CMAKE_COMPILER_IS_GNUCXX)
  add_definitions(-Wno-long-long -Wno-char-subscripts)
  add_definitions(-Wall -ansi -pedantic)
endif()

add_subdirectory(src)
add_subdirectory(demo)

if (NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/package/)
    MESSAGE(STATUS "package dir not found")
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/package/)
endif()

########### install files ###############
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libzrtpcpp.pc DESTINATION ${LIBDIRNAME}/pkgconfig)

if(${PROJECT_NAME} STREQUAL ${CMAKE_PROJECT_NAME})

    ########### Add uninstall target ###############
    configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
    add_custom_target(uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

endif()

=== demo/CMakeLists.txt ===
########### next target ###############

add_executable(zrtptest zrtptest.cpp)
target_link_libraries(zrtptest zrtpcpp)
add_dependencies(zrtptest zrtpcpp)

########### next target ###############

add_executable(zrtptestMulti zrtptestMulti.cpp)
target_link_libraries(zrtptestMulti zrtpcpp)
add_dependencies(zrtptestMulti zrtpcpp)

########### next target ###############

#add_executable(wrappertest wrappertest.c)
#target_link_libraries(wrappertest zrtpcpp)

########### install files ###############
# None

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

# add_subdirectory(libzrtpcpp)
# add_subdirectory(libzrtpcpp/crypto)

include_directories (${CMAKE_CURRENT_SOURCE_DIR})

set(gcrypt_src
    libzrtpcpp/crypto/gcrypt/gcryptZrtpDH.cpp
    libzrtpcpp/crypto/gcrypt/gcrypthmac256.cpp
    libzrtpcpp/crypto/gcrypt/gcryptsha256.cpp
    libzrtpcpp/crypto/gcrypt/gcrypthmac384.cpp
    libzrtpcpp/crypto/gcrypt/gcryptsha384.cpp
    libzrtpcpp/crypto/gcrypt/gcryptAesCFB.cpp
    libzrtpcpp/crypto/gcrypt/InitializeGcrypt.cpp)

set(openssl_src
    libzrtpcpp/crypto/openssl/ZrtpDH.cpp
    libzrtpcpp/crypto/openssl/hmac256.cpp
    libzrtpcpp/crypto/openssl/sha256.cpp
    libzrtpcpp/crypto/openssl/hmac384.cpp
    libzrtpcpp/crypto/openssl/sha384.cpp
    libzrtpcpp/crypto/openssl/AesCFB.cpp
    libzrtpcpp/crypto/openssl/InitializeOpenSSL.cpp)

if (GCRYPT_FOUND)
    set(crypto_src ${gcrypt_src})
endif()

if (OPENSSL_FOUND)
    set(crypto_src ${openssl_src})
endif()

if(enable_ccrtp)
  set(ccrtp_src ZrtpQueue.cpp)
endif()

set(twofish_srcs libzrtpcpp/crypto/twofish.c
         libzrtpcpp/crypto/twofish_cfb.c
         libzrtpcpp/crypto/TwoCFB.cpp)

set(zrtp_src
    ZrtpCallbackWrapper.cpp
    ZIDFile.cpp
    ZIDRecord.cpp
    ZRtp.cpp
    ZrtpCrc32.cpp
    ZrtpPacketCommit.cpp
    ZrtpPacketConf2Ack.cpp
    ZrtpPacketConfirm.cpp
    ZrtpPacketDHPart.cpp
    ZrtpPacketGoClear.cpp
    ZrtpPacketClearAck.cpp
    ZrtpPacketHelloAck.cpp
    ZrtpPacketHello.cpp
    ZrtpPacketError.cpp
    ZrtpPacketErrorAck.cpp
    ZrtpPacketPingAck.cpp
    ZrtpPacketPing.cpp
    ZrtpStateClass.cpp
    ZrtpTextData.cpp
    ZrtpConfigure.cpp
    ZrtpCWrapper.cpp
    Base32.cpp)

set(zrtpcpp_src ${zrtp_src} ${ccrtp_src} ${crypto_src} ${twofish_srcs})

if(BUILD_STATIC AND NOT BUILD_SHARED)
	set(LIBRARY_BUILD_TYPE STATIC)
else()
	set(LIBRARY_BUILD_TYPE SHARED)
endif()

add_library(zrtpcpp ${LIBRARY_BUILD_TYPE} ${zrtpcpp_src})
set_target_properties(zrtpcpp PROPERTIES VERSION ${VERSION} SOVERSION ${SOVERSION})
target_link_libraries(zrtpcpp ${LIBS})
add_dependencies(zrtpcpp ccrtp)
add_subdirectory(libzrtpcpp)

install(TARGETS zrtpcpp DESTINATION ${LIBDIRNAME})

=== src/libzrtpcpp/CMakeLists.txt ===

if(enable_ccrtp)
  set(ccrtp_inst ZrtpQueue.h zrtpccrtp.h ZrtpUserCallback.h TimeoutProvider.h)
endif()

install(FILES 
    ZrtpCodes.h ZrtpConfigure.h ZrtpCallback.h ZrtpCWrapper.h 
    ${ccrtp_inst} DESTINATION include/libzrtpcpp)

=== debian/changelog ===
libzrtpcpp (2.0.0-3build2) trusty; urgency=low

  * Rebuild arm64 against libucommon6.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Thu, 31 Oct 2013 00:27:56 +0000

libzrtpcpp (2.0.0-3build1) trusty; urgency=low

  * Rebuild against libucommon6.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 25 Oct 2013 15:22:00 +0100

libzrtpcpp (2.0.0-3) unstable; urgency=low

  * wheezy polish - lintian clean
  * Update Standards-Version: 3.9.3
  * Add source/format 3.0 (quilt)
  * Update debian/copyright - fix copyright-refers-to-symlink-license
  * debian/compat -> 9

 -- Mark Purcell <msp@debian.org>  Sun, 24 Jun 2012 22:09:11 +1000

libzrtpcpp (2.0.0-2) unstable; urgency=low

  * Added Build-Depends: cmake
  * Upstream:
    - Fixes "FTBFS with gcc-4.7: missing include" (Closes: #672942)
    - Fixes "FTBFS in sid: No package 'libccrtp1' found" (Closes: #673255)

 -- Mark Purcell <msp@debian.org>  Sat, 19 May 2012 21:39:32 +1000

libzrtpcpp (2.0.0-1) unstable; urgency=low

  * New upstream release
  * NEW package libzrtpcpp2 - match-soname
  * Upload to unstable - coordinated through debian-release
  * Switch to dh 7 
  * Add Build-Depends: libucommon & libssl
  * Ack NMUs - Thanks Matthias & Andreas

 -- Mark Purcell <msp@debian.org>  Sat, 19 May 2012 11:16:39 +1000

libzrtpcpp (1.4.6-1.2) unstable; urgency=low

  * Non maintainer upload.
  * Fix build failure with GCC 4.7. Closes: #667261.

 -- Matthias Klose <doko@debian.org>  Tue, 17 Apr 2012 08:32:37 +0200

libzrtpcpp (1.4.6-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Stop shipping libtool la file. Closes: #620607
    http://wiki.debian.org/ReleaseGoals/LAFileRemoval

 -- Andreas Metzler <ametzler@debian.org>  Sun, 24 Apr 2011 14:13:20 +0200

libzrtpcpp (1.6.0-1) experimental; urgency=low

  * New upstream release
  * NEW package libzrtpcpp-1.6-0 - soname bump

 -- Mark Purcell <msp@debian.org>  Sun, 30 Jan 2011 18:46:47 +1100

libzrtpcpp (1.4.6-1) unstable; urgency=low

  * New upstream release 

 -- Mark Purcell <msp@debian.org>  Fri, 30 Oct 2009 23:00:05 +1100

libzrtpcpp (1.4.5-1) unstable; urgency=low

  * New upstream release

  [ Kilian Krause ]
  * Remove -N from wget args in get-orig-source target as -O is already
    used.

 -- Mark Purcell <msp@debian.org>  Wed, 15 Jul 2009 20:36:59 +1000

libzrtpcpp (1.4.3-3) unstable; urgency=low

  * Upload to unstable
    - libcommoncpp2 transition

 -- Mark Purcell <msp@debian.org>  Thu, 26 Feb 2009 18:31:25 +1100

libzrtpcpp (1.4.3-1) experimental; urgency=low

  * New upstream release

 -- Mark Purcell <msp@debian.org>  Sun, 08 Feb 2009 11:26:39 +1100

libzrtpcpp (1.4.2-1) experimental; urgency=low

  * New upstream release

 -- Mark Purcell <msp@debian.org>  Tue, 03 Feb 2009 21:29:49 +1100

libzrtpcpp (1.4.1-1) experimental; urgency=low

  * New upstream release

 -- Mark Purcell <msp@debian.org>  Tue, 23 Dec 2008 17:36:27 +1100

libzrtpcpp (1.4.0-1) experimental; urgency=low

  * New upstream release
    - first release that is conformant to the ZRTP specification

  [ Patrick Matthäi ]
  * Bumped to Standards-Version 3.8.0.

  [ Mark Purcell ]
  * NEW libzrtpcpp-1.4-0 - lintian:package-name-doesnt-match-sonames
  * Add ${misc:Depends} - fixes lintian:debhelper-but-no-misc-depends
  * debian/watch opts=pasv
  * Update debian/copyright

 -- Mark Purcell <msp@debian.org>  Sun, 30 Nov 2008 11:42:37 +1100

libzrtpcpp (1.3.0-1) unstable; urgency=low

  * New upstream release
  * New Package: libzrtpcpp-1.3-0 - soname bump
    - Upload discussed with debian-release

 -- Mark Purcell <msp@debian.org>  Sun, 22 Jun 2008 10:01:03 +1000

libzrtpcpp (1.2.0-1) unstable; urgency=low

  * New upstream release
    - Implements latest changes to ZRTP draft
  * DEB_INSTALL_CHANGELOGS_ALL := NEWS
  * New Package: libzrtpcpp-1.2-0 soname bump
    - Upload cleared with debian-release

 -- Mark Purcell <msp@debian.org>  Fri, 13 Jun 2008 08:18:39 +1000

libzrtpcpp (1.1.0-1) unstable; urgency=low

  * New upstream release
  * Package: libzrtpcpp-1.1-0 due to soname bump

 -- Mark Purcell <msp@debian.org>  Tue, 29 Apr 2008 22:52:58 +1000

libzrtpcpp (0.9.2-3) unstable; urgency=low

  [ Mark Purcell ]
  * Bump LT_RELEASE="0.9.2deb" to cater for upstream ABI breakage
    - ABI breakage - sendDataRTP removed in 0.9.2 (Closes: #445657)
  * Cleanup get-orig-source target

 -- Mark Purcell <msp@debian.org>  Sat, 20 Oct 2007 12:03:24 +0100

libzrtpcpp (0.9.2-2) unstable; urgency=high

  * Fix package names to reflect new ABI - leaving the internal SOVER
    unchanged (Closes: #445657)
  * High urgency due to fixing RC bug.
  * Add myself to Uploaders to make this a non-NMU
  * Adjust DEB_DH_MAKESHLIBS_ARGS_libzrtpcpp-0.9-1 := -V"libzrtpcpp-0.9-1"

 -- Kilian Krause <kilian@debian.org>  Mon, 15 Oct 2007 21:42:05 +0200

libzrtpcpp (0.9.2-1) unstable; urgency=low

  * New upstream release

  [ Kilian Krause ]
  * Add dpkg-dev (>= 1.13.19) to Build-Depends for binary:Version

 -- Mark Purcell <msp@debian.org>  Sun, 30 Sep 2007 12:17:10 +0100

libzrtpcpp (0.9.0-6) unstable; urgency=low

  * DEB_DH_MAKESHLIBS_ARGS_libzrtpcpp-0.9-0 := -V"libzrtpcpp-0.9-0 (>= 0.9.0-4)"
    - Closes: #434590: twinkle: Crashes on every call when using etch
    libraries - Debian Bug report logs
  * Use ${binary:Version} libzrtpcpp source: substvar-source-version-is-
    deprecated

 -- Mark Purcell <msp@debian.org>  Wed, 25 Jul 2007 21:57:34 +0100

libzrtpcpp (0.9.0-5) unstable; urgency=low

  * DEB_DH_MAKESHLIBS_ARGS_libzrtpcpp-0.9-0 := -V"libzrtpcpp-0.9-0 (>= 0.9-4)"
  * Depends: pkg-config

 -- Mark Purcell <msp@debian.org>  Sun, 20 May 2007 16:43:12 +0100

libzrtpcpp (0.9.0-4) unstable; urgency=low

  * Rebuild for libccrtp-dev > 1.5.1 [libccrtp soname]

 -- Mark Purcell <msp@debian.org>  Thu, 12 Apr 2007 21:36:27 +0100

libzrtpcpp (0.9.0-3) unstable; urgency=low

  * Rebuild for libccrtp-dev (>= 1.5.0-3) [libcommoncpp2 soname]

 -- Mark Purcell <msp@debian.org>  Sun,  7 Jan 2007 06:11:31 +0000



=== debian/control ===
Source: libzrtpcpp
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>, Mikael Magnusson <mikma@users.sourceforge.net>, Kilian Krause <kilian@debian.org>
Build-Depends: debhelper (>= 9), autotools-dev, pkg-config, dpkg-dev (>= 1.13.19), cmake,
 libucommon-dev, libccrtp-dev (>= 2.0.3-4ubuntu3), libssl-dev, libgcrypt11-dev | libgcrypt-dev
Standards-Version: 3.9.3
Section: libs
Homepage: http://www.gnu.org/software/ccrtp/
Vcs-Svn: svn://svn.debian.org/pkg-voip/libzrtpcpp/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-voip/libzrtpcpp/?op=log

Package: libzrtpcpp-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libzrtpcpp2 (= ${binary:Version}), pkg-config
Description: Headers and static link library for libzrtpcpp
 This library is an extension to the GNU RTP Stack, libccrtp,
 that offers compatibility with Phil Zimmermann's zrtp/Zfone voice
 encryption, and which can be directly embedded into telephony
 applications.  The current release is conformant to the ZRTP specification.
 .
 This package provides the header files, link libraries, and
 documentation for building applications that use libzrtpcpp.

Package: libzrtpcpp2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ccrtp extension for zrtp/Zfone support
 This library is an extension to the GNU RTP Stack, libccrtp,
 that offers compatibility with Phil Zimmermann's zrtp/Zfone voice
 encryption, and which can be directly embedded into telephony
 applications.  The current release is conformant to the ZRTP specification.

=== debian/rules ===
#!/usr/bin/make -f

export USES_CCRTP_INCLUDE_DIRS=yes

%:
	dh $@ --parallel --with autotools-dev

=== debian/watch ===
# See uscan(1) for format

version=3
opts=pasv ftp://ftp.gnu.org/pub/gnu/ccrtp/libzrtpcpp-(.*)\.tar\.gz debian svn-upgrade

## libzrtpcpp 2.3.4

=== CMakeLists.txt ===
# Copyright (C) 2009 Werner Dittman
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
cmake_minimum_required(VERSION 2.6)

PROJECT(libzrtpcpp)
set (VERSION 2.3.4)
set (PACKAGE libzrtpcpp)
set (SOVERSION ${VERSION})
STRING(REGEX REPLACE "[.].*$" "" SOVERSION ${SOVERSION})

SET(CPACK_PACKAGE_VERSION_MAJOR ${SOVERSION})
SET(CPACK_PACKAGE_VERSION_MINOR ${VERSION})
SET(CPACK_PACKAGE_VERSION_PATCH ${VERSION})
STRING(REGEX REPLACE "[.][0-9]*$" "" CPACK_PACKAGE_VERSION_MINOR ${VERSION})
STRING(REGEX REPLACE ".*[.]" "" CPACK_PACKAGE_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
STRING(REGEX REPLACE ".*[.]" "" CPACK_PACKAGE_VERSION_PATCH ${VERSION})

if(CMAKE_GENERATOR MATCHES "Unix Makefiles")
	add_custom_target(cleandist
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
		COMMAND rm -f "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}[-_]*.gz"
		COMMAND rm -f "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}_*.dsc"
		COMMAND rm -f "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}-*.rpm"
		COMMAND rm -f "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}[-_]*.deb"
    COMMAND rm -f "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}[-_]*.changes"
		COMMAND rm -f "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}-*.zip"
	)

	add_custom_target(dist
		DEPENDS cleandist
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		COMMAND git archive --format tar --output="${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}-${VERSION}.tar" --prefix="${PACKAGE}-${VERSION}/" HEAD
		COMMAND gzip "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}-${VERSION}.tar"
	)
endif()

if(MSVC60)
    set(BUILD_STATIC ON CACHE BOOL "static linking only" FORCE)
    MARK_AS_ADVANCED(BUILD_STATIC)
else()
    option(BUILD_STATIC "Set to OFF to build shared libraries" OFF)
endif()

# set to true for debug and trace during CMakeLists development
set(CMAKE_VERBOSE_MAKEFILE FALSE)

MESSAGE( STATUS "Configuring GNU ${PROJECT_NAME} ${VERSION}...")

# include most of the fine stuff we need
include(cmake/Modules/FindGcryptConfig.cmake)
include(FindPkgConfig)
include(CheckLibraryExists)
include(CheckIncludeFiles)
include(cmake/Modules/AutoArgs.cmake)

if(${PROJECT_NAME} STREQUAL ${CMAKE_PROJECT_NAME})
    include(cmake/Modules/GeneratePackage.cmake)

    GENERATE_PACKAGING(${PACKAGE} ${VERSION})
endif()

# check the -Denable-ccrtp setting, defaults to true
enable_arg(ccrtp true "Enable GNU ccRTP support for GNU ZRTP")
args_help()

if (NOT LIB_SUFFIX)
    set(LIBDIRNAME "lib")
    # this caused problems in debian where it has to always be lib....
    if (NOT EXISTS /etc/debian_version)
        if ( "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" )
            set(LIBDIRNAME "lib64")
        endif()
    endif()
else()
    set(LIBDIRNAME "lib${LIB_SUFFIX}")
endif()

# setup the Thread include and lib
find_package(Threads)
if(CMAKE_HAVE_PTHREAD_H)
  set(HAVE_PTHREAD_H TRUE)
endif()
set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})

# define the name of the lib. zrtpcppcore does not include the ccRTP stuff.
set(zrtplib zrtpcppcore)
if(enable_ccrtp)
    if (USES_CCRTP_INCLUDE_DIRS)
        message(STATUS "  Using local commoncpp dependency")
    else()
        find_package(PkgConfig)
        pkg_check_modules(USES_CCRTP libccrtp>=2.0.0)
    endif()
    include_directories(${USES_CCRTP_INCLUDE_DIRS})
    link_directories(${USES_CRTP_LIBRARY_DIRS})
    add_definitions(${USES_CCRTP_CFLAGS})
    set (LIBS ${LIBS} ${USES_CCRTP_LDFLAGS} ${USES_CCRTP_LIBRARIES})
    set(zrtplib zrtpcpp)
endif()

# now get info about crypto libraries
pkg_check_modules(OPENSSL libcrypto>=0.9.8)
if (OPENSSL_FOUND)
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${OPENSSL_INCLUDE_DIRS}) #update include files search directory
  check_include_files(openssl/bn.h HAVE_OPENSSL_BN_H)
  check_include_files(openssl/aes.h HAVE_OPENSSL_AES_H)
  check_include_files(openssl/sha.h HAVE_OPENSSL_SHA_H)
  check_include_files(openssl/ec.h HAVE_OPENSSL_EC_H)
  check_library_exists(crypto EVP_CipherInit_ex "${OPENSSL_LIBDIR}" HAVE_SSL_CRYPT) #use search lib directory from pkg-config
  set(LIBS ${LIBS} -lcrypto)
  set(CRYPTOBACKEND "libcrypto >= 0.9.8")
  set(BUILD_REQ "libopenssl-devel >= 0.9.8")
  set(PACKAGE_REQ "libopenssl >= 0.9.8")
  include_directories(${OPENSSL_INCLUDE_DIRS}) #update includes directory from pkg-config
endif()

if(NOT HAVE_OPENSSL_EC_H)
  gcr_check(GCRYPT gcrypt)
  if(GCRYPT_FOUND)
    check_include_files(gcrypt.h HAVE_GCRYPT_H)
    set(LIBS ${LIBS} ${GCRYPT_LIBRARIES})
    set(BUILD_REQ "libgcrypt-devel")
    set(CRYPTOBACKEND="")
    set(PACKAGE_REQ "libgcrypt")
  endif()
endif()

if(NOT OPENSSL_FOUND AND NOT GCRYPT_FOUND)
  message(FATAL_ERROR "No crypto library found")
endif()

check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(string.h HAVE_STRING_H)

# necessary and required modules checked, ready to generate config.h
configure_file(libzrtpcpp-config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/libzrtpcpp-config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# the following set(...) commands are only to have backward
# compatibility with autoconf stuff to generate the pc file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix}/bin)
set(libdir ${prefix}/${LIBDIRNAME})
set(includedir ${prefix}/include)
set(PACKAGE pkgconfig)
configure_file(libzrtpcpp.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/lib${zrtplib}.pc @ONLY)

configure_file(libzrtpcpp.spec.cmake ${CMAKE_CURRENT_BINARY_DIR}/libzrtpcpp.spec @ONLY)

#to make sure includes are first taken from those directory
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)

add_definitions(-g -O2 -fno-strict-aliasing)
if(CMAKE_COMPILER_IS_GNUCXX)
  add_definitions(-Wno-long-long -Wno-char-subscripts)
  add_definitions(-Wall -pedantic)
  add_definitions(-DNEW_STDCPP)
endif()

add_subdirectory(src)

if (enable_ccrtp)
    add_subdirectory(demo)
endif()

if (NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/package/)
    MESSAGE(STATUS "package dir not found")
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/package/)
endif()

########### install files ###############
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${zrtplib}.pc DESTINATION ${LIBDIRNAME}/pkgconfig)

if(${PROJECT_NAME} STREQUAL ${CMAKE_PROJECT_NAME})

    ########### Add uninstall target ###############
    configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
    add_custom_target(uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

endif()
##very usefull for macosx, specially when using gtkosx bundler
if(APPLE)
    if (NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib" CACHE STRING "CMAKE_INSTALL_NAME_DIR set for macosx" )
    endif (NOT CMAKE_INSTALL_NAME_DIR)
endif(APPLE)

=== demo/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
 ########### next target ###############
 
 add_executable(zrtptest zrtptest.cpp)
-target_link_libraries(zrtptest zrtpcpp)
+target_link_libraries(zrtptest zrtpcpp ccrtp commoncpp)
 add_dependencies(zrtptest zrtpcpp)
 
 ########### next target ###############
 
 add_executable(zrtptestMulti zrtptestMulti.cpp)
-target_link_libraries(zrtptestMulti zrtpcpp)
+target_link_libraries(zrtptestMulti zrtpcpp ccrtp commoncpp)
 add_dependencies(zrtptestMulti zrtpcpp)
 
 ########### next target ###############

=== debian/changelog ===
libzrtpcpp (2.3.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add missing libssl-dev dependency (Closes: #746655)

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Mon, 31 Aug 2015 14:41:37 +0100

libzrtpcpp (2.3.4-1) unstable; urgency=medium

  * New upstream release
    - Fixes "CVE-2013-2221 CVE-2013-2222 CVE-2013-2223" (Closes: #714650)

 -- Mark Purcell <msp@debian.org>  Wed, 10 Jul 2013 00:55:55 +1000

libzrtpcpp (2.3.2-2) unstable; urgency=low

  * Upload to unstable 
  * Update debian/watch - Thanks Bart
  * Update debian/control - Vcs & Standards-Version:

 -- Mark Purcell <msp@debian.org>  Sun, 12 May 2013 19:08:46 +1000

libzrtpcpp (2.3.2-1) experimental; urgency=low

  * New upstream release

 -- Mark Purcell <msp@debian.org>  Wed, 26 Dec 2012 11:30:07 +1100

libzrtpcpp (2.1.2-1) experimental; urgency=low

  * New upstream release
    - Fixes "new upstream version available" (Closes: #678975)

 -- Mark Purcell <msp@debian.org>  Tue, 26 Jun 2012 07:57:13 +1000

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,17 @@
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Mark Purcell <msp@debian.org>, Mikael Magnusson <mikma@users.sourceforge.net>, Kilian Krause <kilian@debian.org>
 Build-Depends: debhelper (>= 9), autotools-dev, pkg-config, dpkg-dev (>= 1.13.19), cmake,
- libucommon-dev, libccrtp-dev (>= 2.0.3-4ubuntu3), libssl-dev, libgcrypt11-dev | libgcrypt-dev
-Standards-Version: 3.9.3
+ libucommon-dev, libccrtp-dev (>= 2.0.0), libssl-dev, libgcrypt11-dev | libgcrypt-dev
+Standards-Version: 3.9.4
 Section: libs
 Homepage: http://www.gnu.org/software/ccrtp/
-Vcs-Svn: svn://svn.debian.org/pkg-voip/libzrtpcpp/trunk/
-Vcs-Browser: http://svn.debian.org/wsvn/pkg-voip/libzrtpcpp/?op=log
+Vcs-Svn: svn://anonscm.debian.org/pkg-voip/libzrtpcpp/trunk/
+Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-voip/libzrtpcpp/trunk/
 
 Package: libzrtpcpp-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libzrtpcpp2 (= ${binary:Version}), pkg-config
+Depends: ${misc:Depends}, libzrtpcpp2 (= ${binary:Version}), pkg-config, libssl-dev
 Description: Headers and static link library for libzrtpcpp
  This library is an extension to the GNU RTP Stack, libccrtp,
  that offers compatibility with Phil Zimmermann's zrtp/Zfone voice

=== debian/watch ===
version=3
http://ftp.gnu.org/gnu/ccrtp/libzrtpcpp(?:[_\-]?|[_\-]v)(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz|zip)(?:[^\.]\S*)? debian svn-upgrade
# Bart Martens <bartm@debian.org>  Sat, 02 Mar 2013 16:58:05 +0000
